// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "BasePawn.h"
#include "Tower.generated.h"

/**
 * 
 */
UCLASS()
class TOONTANKS_API ATower : public ABasePawn
{
	GENERATED_BODY()

public:
	virtual void Tick(float DeltaTime) override;

protected:
	virtual void BeginPlay() override;

private:
	// Tank Object Pointer which is target
	class ATank* Tank;

	// Distance to Start Tracking the target
	UPROPERTY(EditAnywhere, Category = "Rotate")
	float FireRange = 400.0f;

	// FTimerHandle for SetTimer.
	FTimerHandle FireRateTimerHandle;

	// Fire Period
	float FireRate = 2.0f;

	// Check Tank is in Range. If so, Fire operation occurs. 
	void TryFire();

	// Check Tank is in Fire Range, 
	bool InFireRange() const;
	
};
